{% import "macro/form.twig" as form %}
<style>
	a:visited {
		color: green;
	}
	.btn.btn-primary:visited {
		color: #fff;
	}
	i.fa.fa-times {
		position: absolute;
		right: 10px;
		font-size: 20px;
		top: 10px;
		color: #999;
	}
	i.fa.fa-times:hover {
		color: #000;
	}
	h3 {
		margin: 8px 20px;
		text-align: center;
		color: #888;
	}
	.card-header h4 {
		text-align: center;
	}
	.card-header {
		height: 54px;
	}
</style>
<div
	class="container-fluid">
	{# <a href="/exam/add" class='btn btn-primary fr' visited="#ffffff">Add Question Paper</a> #}
	<h2>Instructions and Marking Scheme</h2>
	<hr>
	<h3>Instructions and Timeout Messages</h3>
	<div class="row">
		<div class="col-sm-4">
			<div class="card">
				<div class="card-header">
					<h4 onclick="popup.instructions()">Instructions</h4>
				</div>
			</div>
		</div>
		<div class="col-sm-4">
			<div class="card">
				<div class="card-header">
					<h4 onclick="popup.timeout()">Timeout</h4>
				</div>
			</div>
		</div>
		<div class="col-sm-4">
			<div class="card">
				<div class="card-header">
					<h4 style="color:red">Not uploaded</h4>
				</div>
			</div>
		</div>
	</div>
	<h3 style='text-align:center'>Marking Scheme (Subjective)</h3>
	<div class="row">
		<div class="form-group col-md-12 form-group">
			<table class='table'>

				<tr>
					<th>#</th>
					<th style='text-align:center'>Section Name</th>
					<th style='text-align:center;width:110px'>Qno(Start)</th>
					<th style='text-align:center;width:110px'>Qno(End)</th>
					<th style='text-align:center;width:110px'>Passing marks</th>
					<th style='text-align:center;width:110px'>Total marks</th>
					<th style='width:110px'></th>
				</tr>
				{% for item in marking.subjective %}
					<tr>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{loop.index}}</td>
						<td style="font-weight:bold;font-size:16px">{{item.section}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.qst}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.qnd}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.passing}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.total}}</td>
						<td>
							<button class="btn btn-primary">Delete</button>
						</td>
					</tr>
				{% endfor %}
				<form method="post">
					<tr>
						<td style="font-weight:600;text-align:center"></td>
						<td><input class='form-control' type="text" name='section'></td>
						<td><input class='form-control' type="text" name='qst'></td>
						<td><input class='form-control' type="text" name='qnd'></td>
						<td><input class='form-control' type="text" name='passing'></td>
						<td><input class='form-control' type="text" name='total'></td>
						<td>
							<button type="submit" class="btn btn-control">Save</button>
						</td>
					</tr>
					{{form.hidden("segment","subjective")}}
					{{form.hidden("action","marking-add")}}
					{{form.hidden("subject",qpinfo[2])}}
					{{form.hidden("title",qpinfo[3])}}
					{{form.hidden("type",qpinfo[4])}}

				</form>
			</table>
			<form method="post">
				{% for item in marking.subjective %}
					<h4>{{item.section|upper}}</h4>
					{% for i in item.qst .. item.qnd %}
						<div class="row" style='border-bottom:1px solid #ccc'>
							<div class="col-sm-2">
								Que
								{{i}}
								{% if subjective["mQ-"~i~"A"] is defined %}

									{% else %}

										(Parts)
										<input type="number" onchange="subparts.create(this.parentElement,this.value)" name="Q-{{i}}" class="form-control">
								{% endif %}
							</div>
							<div class="col-sm-10 row">
								{% for part in range('A','Z') %}
									{% if subjective["mQ-"~i~part] is defined%}
										<div class="col-sm-2">
											{% if part=="A" and subjective["mQ-"~i~"B"] is not defined %}
												<label>Q-{{i}}.
												</label>

											{% else %}
												<label>Q-{{i}}{{part}}.</label>
											{% endif %}
											<input class="form-control" name="mQ-{{i}}{{part}}" value='{{subjective["mQ-"~i~part]}}'>
										</div>
										{# mQ-{{i}}{{part}} &nbsp;{{subjective["mQ-"~i~part]}} #}
									{% endif %}

								{% endfor %}
							</div>
						</div>
					{% endfor %}
				{% endfor %}
				{{form.hidden('action','marking')}}
				<button class="btn btn-primary">Save</button>
			</form>
		</div>
	</div>

	<a name="objective" class="separator" id="objective"></a>

	<h3 style='text-align:center'>Marking Scheme (Objective)</h3>
	<div class="row">
		<div class="form-group col-md-12 form-group">
			<table class='table'>

				<tr>
					<th>#</th>
					<th style='text-align:center'>Section Name</th>
					<th style='text-align:center;width:110px'>Qno(Start)</th>
					<th style='text-align:center;width:110px'>Qno(End)</th>
					<th style='text-align:center;width:110px'>Passing marks</th>
					<th style='text-align:center;width:110px'>Total marks</th>
					<th style='width:110px'></th>
				</tr>
				{% for item in marking.objective %}
					<tr>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{loop.index}}</td>
						<td style="font-weight:bold;font-size:16px">{{item.section}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.qst}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.qnd}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.passing}}</td>
						<td style="text-align:center;font-weight:bold;font-size:16px">{{item.total}}</td>
						<td>
							<button class="btn btn-primary">Delete</button>
						</td>
					</tr>
				{% endfor %}
				<form method="post">
					<tr>
						<td style="font-weight:600;text-align:center"></td>
						<td><input class='form-control' type="text" name='section'></td>
						<td><input class='form-control' type="text" name='qst'></td>
						<td><input class='form-control' type="text" name='qnd'></td>
						<td><input class='form-control' type="text" name='passing'></td>
						<td><input class='form-control' type="text" name='total'></td>
						<td>
							<button type="submit" class="btn btn-control">Save</button>
						</td>
					</tr>
					{{form.hidden("segment","objective")}}
					{{form.hidden("action","marking-add")}}
					{{form.hidden("subject",qpinfo[2])}}
					{{form.hidden("title",qpinfo[3])}}
					{{form.hidden("type",qpinfo[4])}}

				</form>
			</table>
			<form method="post">
				{{form.hidden("category",qpinfo[0])}}
				{{form.hidden("subject",qpinfo[2])}}
				{{form.hidden("title",qpinfo[3])}}
				{{form.hidden("type",qpinfo[4])}}
				{{form.hidden("page","objective")}}
				{% for item in marking.objective %}
					<h4>{{item.section|upper}}</h4>
					<form method="post">
						<table class='table tbl-responsive'>

							<tr>
								<th style='text-align:center'>Question</th>
								<th style='text-align:center'>Answer</th>
								<th style='text-align:center'>Correct Marks</th>
								<th style='text-align:center'>Wrong Marks</th>
								<th style='text-align:center'>Unattempted Marks</th>
							</tr>

							{% for i in item.qst .. item.qnd %}
								<tr class='ans'>
									<td>
										<b style='font-size:18px;'>
											<center>Q-{{i}}</center>
										</b>
									</td>

									{% if ans[i] is defined %}

										<td>
											<input type="text" name="q{{i}}" value="{{ans[i].ans}}" class="form-control">
										</td>
										<td><input class="form-control" step="0.01" name="coq{{i}}" type="number" value='{{ans[i].marks[0]}}'></td>
										<td><input class="form-control" step="0.01" name="wrq{{i}}" type="number" value='{{ans[i].marks[2]}}'></td>
										<td><input class="form-control" step="0.01" name="uaq{{i}}" type="number" value='{{ans[i].marks[1]}}'></td>
									{% else %}

										<td>
											<input type="text" name="q{{i}}" class="form-control">
										</td>
										<td><input class="form-control" step="0.01" name="coq{{i}}" value="1" type="number"></td>
										<td><input class="form-control" step="0.01" name="wrq{{i}}" value="-0.25" type="number"></td>
										<td><input class="form-control" step="0.01" name="uaq{{i}}" value="0" type="number"></td>
									{% endif %}
								</tr>

							{% endfor %}
						</table>
					{% endfor %}
					{{form.hidden('action','ans-update')}}
					<button class="btn btn-primary">Save</button>
				</form>
			</div>
		</div>
	</div>


	<div class="popup" frm='popupfrm'>
		<i onclick="popup.close()" class='fa fa-times'></i>
		<h3 data="heading"></h3>
		<form id="upload" method="POST" enctype="multipart/form-data">
			<fieldset>
				{{form.hidden("name","")}}
				{{form.hidden("subject",qpinfo[2])}}
				{{form.hidden("type",qpinfo[3])}}
				{{form.hidden("title",qpinfo[4])}}

				<div class="page-upload" id="filedrag">
					<legand class="h3"></legand>
					<div>
						<label></label>
						<div id="progress"></div>
						<input style="margin-top:-20px" type="file" id="fileselect" name="file"/>
					</div>
				</div>
				<div class="btn btn-primary fr" onclick="popup.close()">Ok</div>
				{{form.hidden("action","")}}
				{# <button type="submit" class='button btn btn-primary fr'>Upload</button> #}
				<div id="messages" style="display:none"></div>

			</fieldset>

		</form>
	</div>
	<script src="/js/filedrag.js?{{version}}"></script>
	<script>
		instructions = {
open: function (e) {
console.log(e);
var elm = document.querySelector("[frm=popupfrm]");
if (elm != null) 
elm.style = "display:block";



}
}
var popup = {
close: function () {
document.querySelector("[frm=popupfrm]").style = "";
},
instructions: function () {
el = location.pathname.split("/");
console.log(el);
var info = [
el[3], el[4], el[5]
];
var elm = document.querySelector("[frm=popupfrm]");
if (elm == null) {
alert("This section is not working,  Please contact the adminstrator.");
} else {
elm.style = "display:block";
var flds = {
heading: elm.querySelector("[data=heading]"),
name: elm.querySelector("[name=name]"),
subject: elm.querySelector("[name=subject]"),
type: elm.querySelector("[name=type]"),
action: elm.querySelector("[name=action]")
}
flds.heading.innerHTML = "Upload Instructions";
flds.name.value = info[1];
flds.subject.value = info[0];
flds.type.value = info[2];
flds.action.value = "upload-instructions";
}
},
timeout: function () {
el = location.pathname.split("/");
console.log(el);
var info = [
el[3], el[4], el[5]
];
var elm = document.querySelector("[frm=popupfrm]");
if (elm == null) {
alert("This section is not working,  Please contact the adminstrator.");
} else {
elm.style = "display:block";
var flds = {
heading: elm.querySelector("[data=heading]"),
name: elm.querySelector("[name=name]"),
subject: elm.querySelector("[name=subject]"),
type: elm.querySelector("[name=type]"),
action: elm.querySelector("[name=action]")
}
flds.heading.innerHTML = "Time out Message";
flds.name.value = info[1];
flds.subject.value = info[0];
flds.type.value = info[2];
flds.action.value = "upload-timeout*";
}
}
}
var subparts = {
create: function (p, e) { // console.log(e.name);
console.log(e);
console.log(p.querySelector("[name]").name);
var qno = p.querySelector("[name]").name;
var parts = p.parentElement.querySelector(".col-sm-10");
for (i = 0; i < e; i ++) { // console.log(String.fromCharCode(65+i));
flds = document.createElement("div");
flds.classList.add("col-sm-2");
var lbl = document.createElement("label");
if (e != 1) 
lbl.innerHTML = qno + " " + String.fromCharCode(65 + i);
 else 
lbl.innerHTML = qno;



flds.append(lbl);
inp = document.createElement("input");
inp.classList.add("form-control");
inp.name = "m" + qno + String.fromCharCode(65 + i);
flds.append(inp);

parts.append(flds);
}

}
}

document.onkeydown = checkKey;

function checkKey(e) {
e = e || window.event;
var elm = document.querySelector("input:focus").name;
let qno;
if (elm.startsWith("q")) {
var curq = elm.split("q");
qno = parseInt(curq[1]);
}
if (e.keyCode == '38') {
qno--;
if (document.querySelector("[name=q" + qno + "]") != null) 
document.querySelector("[name=q" + qno + "]").focus();

} else if (e.keyCode == '40') {
qno++;
if (document.querySelector("[name=q" + qno + "]") != null) 
document.querySelector("[name=q" + qno + "]").focus();

}

}
	</script>
